package org.dromara.work.service;

import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.bo.OrderRankingBo;
import org.dromara.work.domain.bo.TpWechatBo;
import org.dromara.work.domain.vo.TpWechatVo;
import org.dromara.work.domain.vo.WechatSumVo;
import org.dromara.work.domain.vo.WxNumDayListVo;

import java.util.Collection;
import java.util.List;

/**
 * 基本信息Service接口
 *
 * @author Maosw
 * @date 2024-08-12
 */
public interface ITpWechatService {

    /**
     * 查询基本信息
     *
     * @param id 主键
     * @return 基本信息
     */
    TpWechatVo queryById(Long id);

    /**
     * 分页查询基本信息列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 基本信息分页列表
     */
    TableDataInfo<TpWechatVo> queryPageList(TpWechatBo bo, PageQuery pageQuery);

    /**
     * 查询符合条件的基本信息列表
     *
     * @param bo 查询条件
     * @return 基本信息列表
     */
    List<TpWechatVo> queryList(TpWechatBo bo);

    /**
     * 新增基本信息
     *
     * @param bo 基本信息
     * @return 是否新增成功
     */
    Boolean insertByBo(TpWechatBo bo);

    /**
     * 修改基本信息
     *
     * @param bo 基本信息
     * @return 是否修改成功
     */
    Boolean updateByBo(TpWechatBo bo);

    /**
     * 校验并批量删除基本信息信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid);

    /**
     * 修改使用人
     *
     * @param bo
     * @return
     */
    boolean updateUserByBo(TpWechatBo bo);

    /**
     * 微信信息统计
     *
     * @param bo
     * @return
     */
    WechatSumVo queryListSum(TpWechatBo bo);

    /**
     * 微信日统计
     * @param bo
     * @param wxIds
     * @return
     */
    List<WxNumDayListVo> wxDayList(OrderRankingBo bo, List<Long> wxIds);

    /**
     * 微信月统计
     * @param bo
     * @param wxIds
     * @return
     */
    List<WxNumDayListVo> wxMonthList(OrderRankingBo bo, List<Long> wxIds);

    List<TpWechatVo> queryListByIds(List<Long> userIds);
}
